<template>
  <form class="row flex flex-center" @submit.prevent="handleLogin">
    <div class="col-6 form-widget">
      <h1 class="text-5xl py-5">Dashboard</h1>
      <p class="description">Sign in via magic link with your email below</p>
      <div>
        <input
          class="inputField"
          type="email"
          placeholder="Your email"
          v-model="email"
        />
      </div>
      <div>
        <input
          type="submit"
          class="button block"
          :value="loading ? 'Loading' : 'Send magic link'"
          :disabled="loading"
        />
      </div>
    </div>
    <Modal v-if="modal" @close="modal = false" :is-close="false" is-confirm>
      <template v-slot:body>
        <div class="text-4xl">{{modalMessages}}</div>
      </template>
    </Modal>
  </form>
</template>

<script>
import { ref } from "vue"
import { supabase } from "../supabase"
import Modal from "./Modal.vue";
export default {
  name: "Auth",
  components: {Modal},
  setup() {
    const modal = ref(false)
    const modalMessages = ref('')

    const loading = ref(false)
    const email = ref("")
    const handleLogin = async () => {
      try {
        loading.value = true
        const { error } = await supabase.auth.signIn({ email: email.value })
        if (error) throw error
        modalMessages.value = 'Check your email for the login link!'
        modal.value = true // Check your email for the login link!
      } catch (error) {
        modalMessages.value = error.error_description || error.message
        modal.value = true // error 
      } finally {
        loading.value = false
      }
    }

    return {
      loading,
      email,
      modal,
      modalMessages,

      handleLogin,
    }
  },
}
</script>

<style scoped>

</style>
